using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DemoDDB_Csharp.AutoComplete
{
	/// <summary>
	/// Summary description for AutoComplete.
	/// </summary>
	public class AutoComplete : System.Windows.Forms.UserControl
	{
		internal AlterS.DDButton ddbAutoComplete;
		private  TextBox txtAutoComplete;
	
		struct PointApi
		{
			public int x, y;
			public PointApi(int x, int y) 
			{
				this.x = x;
				this.y = y;
			}
		}

		private int PositionToInsert;

		[DllImport("user32.dll")]
		private static extern int GetCaretPos(ref PointApi lpPoint);
		[DllImport("user32.dll")]
		private static extern int ClientToScreen(int hwnd, ref PointApi lpPoint);


		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AutoComplete()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddbAutoComplete = new AlterS.DDButton();
			this.SuspendLayout();
			// 
			// ddbAutoComplete
			// 
			this.ddbAutoComplete.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbAutoComplete.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			this.ddbAutoComplete.AllowDrop = true;
			this.ddbAutoComplete.AllowFocusAndProcessKeyMessages = false;
			this.ddbAutoComplete.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow;
			this.ddbAutoComplete.AutoHideOnLastTab = true;
			this.ddbAutoComplete.AutoSize = false;
			this.ddbAutoComplete.BackColor = System.Drawing.SystemColors.Window;
			this.ddbAutoComplete.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft;
			this.ddbAutoComplete.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D;
			this.ddbAutoComplete.DockPadding.Bottom = 1;
			this.ddbAutoComplete.DockPadding.Left = 1;
			this.ddbAutoComplete.DockPadding.Top = 1;
			this.ddbAutoComplete.DockPaddingRightInternal = 0;
			this.ddbAutoComplete.EnableDrawText = false;
			this.ddbAutoComplete.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbAutoComplete.IsContainer = false;
			this.ddbAutoComplete.IsFormActiveAfterDrop = false;
			this.ddbAutoComplete.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbAutoComplete.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbAutoComplete.Location = new System.Drawing.Point(4, 4);
			this.ddbAutoComplete.Name = "ddbAutoComplete";
			this.ddbAutoComplete.Size = new System.Drawing.Size(16, 27);
			this.ddbAutoComplete.SupportXPStyle = true;
			this.ddbAutoComplete.TabIndex = 3;
			// 
			// AutoComplete
			// 
			this.Controls.Add(this.ddbAutoComplete);
			this.Name = "AutoComplete";
			this.Size = new System.Drawing.Size(24, 36);
			this.ResumeLayout(false);

		}
		#endregion



		private void InitializeDDB()
		{
			frmTemplateAutoComplete frmTmpObj;

			frmTmpObj = (new frmTemplateAutoComplete());
			ddbAutoComplete.IsContainer = false;
			ddbAutoComplete.SetFormToDrop(frmTmpObj);
			frmTmpObj.FillListBox();

			ddbAutoComplete.Notify+=new AlterS.DDButton.NotifyEventHandler(ddbAutoComplete_Notify);


			this.Resize +=new EventHandler(AutoComplete_Resize);

			AutoComplete_Resize(null, null);
		}

		public void SetParentControl(TextBox tb){
			txtAutoComplete=tb;
			ddbAutoComplete.SetParentControl (txtAutoComplete);

			txtAutoComplete.KeyDown+=new KeyEventHandler(txtAutoComplete_KeyDown);
			txtAutoComplete.KeyPress+=new KeyPressEventHandler(txtAutoComplete_KeyPress);
		}

		
		private void txtAutoComplete_KeyDown(object sender, KeyEventArgs e)
		{

			frmTemplateAutoComplete f;
			f = (frmTemplateAutoComplete)ddbAutoComplete.RefToFrmToDrop;

			if (f == null) {return;}

			if (f.Visible) 
			{
				switch (e.KeyValue)
				{
					case ((int)Keys.Escape):
						ddbAutoComplete.HideDroppedForm();
						break;
					case((int)Keys.Down):
					case((int)Keys.Up):
						ddbAutoComplete.SetDroppedFormAsActive();
						f.ListBox1.Focus();
						e.Handled = true;
						break;
					default:
						break;
				}
			}
		}

		private void txtAutoComplete_KeyPress(object sender, KeyPressEventArgs e)
		{
			frmTemplateAutoComplete f;
			AlterS.DDButton d = null;
			PointApi p ;
			int KeyAscii;
			
			p= new PointApi(0,0);
 
			f = (frmTemplateAutoComplete)ddbAutoComplete.RefToFrmToDrop;

			if (f == null ) {return;}

			KeyAscii = System.Convert.ToInt32(e.KeyChar);

			if (f.Visible){ f.HandleKeyPressInParentControl(KeyAscii);}

			if ((KeyAscii == (int)Keys.Enter) && f.Visible)
			{
				e.Handled = true;
				f.DataExchMode = 1;
				ddbAutoComplete_Notify(ref d);
				ddbAutoComplete.HideDroppedForm();
				return;
			}

			// show autocomplete tool on "."
			if ((KeyAscii == 46) & (! f.Visible))
			{
				PositionToInsert = txtAutoComplete.SelectionStart + 1;

				//--------- Initialize variables
				f.ListBox1.SelectedIndex = 0;
				f.IsMouseClick = false;
				//---------------------------------------

				GetCaretPos(ref p);
				ClientToScreen(txtAutoComplete.Handle.ToInt32(), ref p);

				ddbAutoComplete.DropDown(p.x, (int)(p.y + 2 * txtAutoComplete.Font.Size), (int)(2 * txtAutoComplete.Font.Size));

				return;
			}

			// this is to supress change of the text in the textbox 
			// when auto complete tool is visible
			if (f.Visible){ e.Handled = true;}
		}


		private void ddbAutoComplete_Notify(ref AlterS.DDButton sender)
		{
			frmTemplateAutoComplete f;
			string txtToIns, basetxt;
			
			f = (frmTemplateAutoComplete)ddbAutoComplete.RefToFrmToDrop;

			if (f == null ) {return;}

			txtToIns = f.ListBox1.SelectedItem.ToString();
			basetxt = txtAutoComplete.Text;

			switch (f.DataExchMode)
			{
				case (1):
					txtAutoComplete.Text=txtAutoComplete.Text.Insert(PositionToInsert,txtToIns);
					txtAutoComplete.SelectionStart = 
						PositionToInsert + txtToIns.Length;
					break;
				case (2):
					//txtAutoComplete.Text = txtAutoComplete.Text + f.TypedChar.ToString();
					break;
			}
		}

		private void AutoComplete_Resize(object sender, EventArgs e)
		{
			ddbAutoComplete.Top = 0;
			ddbAutoComplete.Left = 0;
			this.Height = ddbAutoComplete.Height;
			this.Width = ddbAutoComplete.Width;
		}
	}
}
