using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DemoDDB_Csharp
{
	/// <summary>
	/// Summary description for DropDownCheckList.
	/// </summary>
	public class DropDownCheckList : System.Windows.Forms.UserControl
	{
		internal AlterS.DDButton ddbCheckList;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownCheckList()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddbCheckList = new AlterS.DDButton();
			this.SuspendLayout();
			// 
			// ddbCheckList
			// 
			this.ddbCheckList.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbCheckList.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			this.ddbCheckList.AllowDrop = true;
			this.ddbCheckList.AllowFocusAndProcessKeyMessages = false;
			this.ddbCheckList.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow;
			this.ddbCheckList.AutoHideOnLastTab = false;
			this.ddbCheckList.AutoSize = true;
			this.ddbCheckList.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ddbCheckList.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft;
			this.ddbCheckList.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.ddbCheckList.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D;
			this.ddbCheckList.DockPadding.Bottom = 1;
			this.ddbCheckList.DockPadding.Left = 1;
			this.ddbCheckList.DockPadding.Right = 18;
			this.ddbCheckList.DockPadding.Top = 1;
			this.ddbCheckList.DockPaddingRightInternal = 0;
			this.ddbCheckList.EnableDrawText = false;
			this.ddbCheckList.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ddbCheckList.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbCheckList.InternalHeight = 18;
			this.ddbCheckList.IsContainer = true;
			this.ddbCheckList.IsFormActiveAfterDrop = false;
			this.ddbCheckList.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbCheckList.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbCheckList.Location = new System.Drawing.Point(4, 6);
			this.ddbCheckList.Name = "ddbCheckList";
			this.ddbCheckList.Size = new System.Drawing.Size(144, 20);
			this.ddbCheckList.SupportXPStyle = true;
			this.ddbCheckList.TabIndex = 18;
			// 
			// DropDownCheckList
			// 
			this.Controls.Add(this.ddbCheckList);
			this.Name = "DropDownCheckList";
			this.Size = new System.Drawing.Size(156, 42);
			this.ResumeLayout(false);

		}
		#endregion



		private void InitializeDDB() {
		
			Form frmTmpObj;
			frmTmpObj = new frmTemplateCheckList();

            ddbCheckList.Left = 0;
            ddbCheckList.Top = 0;

            ddbCheckList.SetFormToDrop(frmTmpObj);
            ddbCheckList.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
            ddbCheckList.IsFormActiveAfterDrop = true;
            ddbCheckList.EnableDrawText = true;
            ddbCheckList.AllowFocusAndProcessKeyMessages = true;
            ddbCheckList.DockPaddingRightInternal = 2;
            ddbCheckList.AutoSize = true;
            ddbCheckList.Text = "Click here...";

			frmTmpObj.Hide();

			ddbCheckList.Notify +=new AlterS.DDButton.NotifyEventHandler(ddbCheckList_Notify);
			ddbCheckList.Resize +=new AlterS.DDButton.ResizeEventHandler(ddbCheckList_Resize);
			this.Resize +=new EventHandler(DropDownCheckList_Resize);

			DropDownCheckList_Resize(null,null);
		}

		private void DropDownCheckList_Resize(object sender, EventArgs e)
		{
			ddbCheckList.Width = this.Width;

			//since we use ddbCheckList.AutoSize = true 
			//we need adjust the control height (not the DDButton height)

			this.Height = ddbCheckList.Height;

		}

		private void ddbCheckList_Notify(ref AlterS.DDButton sender)
		{
			frmTemplateCheckList f;
			f = (frmTemplateCheckList)ddbCheckList.RefToFrmToDrop;

			switch (f.ValueToSet)
			{
				case ("0"):
					ddbCheckList.Text = " No topics are selected";
					break;
				case ("1"):
					ddbCheckList.Text = " 1 topic is selected";
					break;
				default:
					ddbCheckList.Text = " " + f.ValueToSet + " topics are selected";
					break;
			};
			

		}

		private void ddbCheckList_Resize(object sender, EventArgs e)
		{
			this.Height = ddbCheckList.Height;
		}
	}

}
