using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DemoDDB_Csharp
{
	/// <summary>
	/// Summary description for frmTemplateDataGrid.
	/// </summary>
	public class frmTemplateDataGrid : System.Windows.Forms.Form
	{
		public AlterS.DDButton ParentDDButton;  
		public string ValueToSet;

		private const int InitRowSel = -2; // since HitTest returns -1 when no row selected lets use -2
		private const int border_width = 1;

		private int PrevRowSel = InitRowSel;
		private int X = 0;
		private int Y = 0;

		private DataGridWithKeyDownEvents dataGrid1;
		private System.Data.DataSet dataSet1;
		public AlterS.Grip grip1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmTemplateDataGrid()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			LoadData();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new DemoDDB_Csharp.DataGridWithKeyDownEvents();
			this.dataSet1 = new System.Data.DataSet();
			this.grip1 = new AlterS.Grip();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataSet1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 0);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(292, 196);
			this.dataGrid1.TabIndex = 0;
			// 
			// dataSet1
			// 
			this.dataSet1.DataSetName = "NewDataSet";
			this.dataSet1.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// grip1
			// 
			this.grip1.AdjustXShift = 4;
			this.grip1.AdjustYShift = 4;
			this.grip1.AutoAdjustPosition = true;
			this.grip1.BackColor = System.Drawing.Color.LightGreen;
			this.grip1.EdgeStyle = AlterS.GripEnum.EdgeStyles.BUMP;
			this.grip1.Location = new System.Drawing.Point(236, 178);
			this.grip1.Name = "grip1";
			this.grip1.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpBOTTOM_RIGHT;
			this.grip1.Size = new System.Drawing.Size(8, 8);
			this.grip1.Style = AlterS.GripEnum.GripStyles.grpSquare;
			this.grip1.TabIndex = 1;
			this.grip1.TabStop = false;
			// 
			// frmTemplateDataGrid
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 196);
			this.Controls.Add(this.grip1);
			this.Controls.Add(this.dataGrid1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "frmTemplateDataGrid";
			this.ShowInTaskbar = false;
			this.Text = "frmTemplateDataGrid";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataSet1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public void LoadData()
		{

			System.Data.DataTable dataTable1 = new System.Data.DataTable("Books");
			System.Data.DataColumn dc1 = new System.Data.DataColumn("Author");
			System.Data.DataColumn dc2 = new System.Data.DataColumn("Book");

			DataGridTableStyle grdTableStyle1 = new DataGridTableStyle();
			DataGridTextBoxColumn grdColStyle1 = new DataGridTextBoxColumn();
			DataGridTextBoxColumn grdColStyle2 = new DataGridTextBoxColumn();

			System.Data.DataRow newRow1;
			int i;

			this.DockPadding.All = border_width;
			this.BackColor = Color.Black;

			dataTable1.Columns.Add(dc1);
			dataTable1.Columns.Add(dc2);

			dataSet1.Tables.Add(dataTable1);

			for (i = 1; i<= 100;i++)
			{
				newRow1=dataTable1.NewRow();
				newRow1[0] = "Author name " + i;
				newRow1[1] = "Book title " + (100 - i);
				dataTable1.Rows.Add(newRow1);
			}

			grdColStyle1.HeaderText = "Author";
			grdColStyle1.MappingName = "Author";
			grdColStyle1.Width = 100;

			grdColStyle2.HeaderText = "Book";
			grdColStyle2.MappingName = "Book";
			grdColStyle2.Width = 125;

			grdTableStyle1.AlternatingBackColor = Color.AliceBlue;
			grdTableStyle1.HeaderBackColor = Color.LightSlateGray;
			grdTableStyle1.HeaderForeColor = Color.White;
			dataGrid1.BackgroundColor = Color.WhiteSmoke;

			grdTableStyle1.RowHeaderWidth = 25;
			grdTableStyle1.MappingName = "Books";
			grdTableStyle1.GridColumnStyles.AddRange (new DataGridColumnStyle[2]{grdColStyle1, grdColStyle2});

			dataGrid1.CaptionVisible = false;
			dataGrid1.ReadOnly = true;
			dataGrid1.DataSource = dataSet1.Tables[0];
			dataGrid1.TableStyles.Add(grdTableStyle1);
			dataGrid1.Show(); 
	
			dataGrid1.MouseDown +=new MouseEventHandler(dataGrid1_MouseDown);
			dataGrid1.KeyDown +=new KeyEventHandler(dataGrid1_KeyDown);

			Object o;
			o=  this;
			grip1.SetObjectToResize(ref o);
            grip1.AdjustXShift = 0;
            grip1.AdjustYShift = 0;
			grip1.GotFocus +=new EventHandler(grip1_GotFocus);

			dataGrid1.MouseMove +=new MouseEventHandler(dataGrid1_MouseMove);
			dataGrid1.CurrentCellChanged +=new EventHandler(dataGrid1_CurrentCellChanged);
		}


		private void dataGrid1_MouseDown(object sender, MouseEventArgs e)
		{
			if ((e.Button & MouseButtons.Left) !=0 )
			{

				// Use the HitTest method to get a HitTestInfo object.
				DataGrid.HitTestInfo hi;
				DataGrid grid;

				grid = (DataGrid) sender; 
				hi = grid.HitTest(e.X, e.Y);

				// Test if the clicked area was a cell.
				if (hi.Type == System.Windows.Forms.DataGrid.HitTestType.Cell) {
					if (ParentDDButton != null) 
					{
						ValueToSet = dataGrid1[hi.Row, 1] 
							+ ", " + dataGrid1[hi.Row, 0];

						ParentDDButton.RaiseEventNotify();
						ParentDDButton.HideDroppedForm();
					}
				}
			}
		}

		private void dataGrid1_KeyDown(object sender, KeyEventArgs e)
		{
			switch (e.KeyValue) {
				case ((int)Keys.Enter):  
					if (ParentDDButton != null) 
					{
						ValueToSet = dataGrid1[dataGrid1.CurrentRowIndex, 1] 
							+ ", " + dataGrid1[dataGrid1.CurrentRowIndex, 0];

						ParentDDButton.RaiseEventNotify();
						ParentDDButton.HideDroppedForm();
					}

					break;
				case ((int)Keys.Escape):  
					if (ParentDDButton != null){
						ParentDDButton.HideDroppedForm();
					}

					break;
			}
		}

		private void grip1_GotFocus(object sender, EventArgs e)
		{
			dataGrid1.Focus ();
		}


		private void dataGrid1_MouseMove(object sender, MouseEventArgs e)
		{
			if (X == e.X & Y == e.Y){
				return; //No move. Sometimes DataGrid generates MouseMove even if there is no real move.
			}

			X = e.X;
			Y = e.Y;


			if (e.Button == MouseButtons.None)
			{
				// Use the HitTest method to get a HitTestInfo object.
				DataGrid.HitTestInfo hi;
				DataGrid grid  = (DataGrid)sender;

				hi = grid.HitTest(e.X, e.Y);
				if (PrevRowSel == hi.Row || hi.Row == -1 ) {return;}

				// Test if the clicked area was a cell.
				if (hi.Type == System.Windows.Forms.DataGrid.HitTestType.Cell)
				{
					if (PrevRowSel != InitRowSel)
					{
						dataGrid1.UnSelect(PrevRowSel);
					}
					else
					{
						dataGrid1.UnSelect(0);
					}
					dataGrid1.Select(hi.Row);
					dataGrid1.CurrentRowIndex = hi.Row;
					PrevRowSel = hi.Row;
				}
			}
		}

		private void dataGrid1_CurrentCellChanged(object sender, EventArgs e)
		{
			if (PrevRowSel != InitRowSel) {
				dataGrid1.UnSelect(PrevRowSel);
			}
			dataGrid1.Select(dataGrid1.CurrentRowIndex);
			PrevRowSel = dataGrid1.CurrentRowIndex;
		}

		public void SelectRow()
		{
			if (PrevRowSel == InitRowSel){
				dataGrid1.Select(0);
			}
			else{
				dataGrid1.Select(PrevRowSel);
			}
		}
	}
}
