using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DemoDDB_Csharp
{
	/// <summary>
	/// Summary description for DropDownListWithToolbar.
	/// </summary>
	public class DropDownListWithToolbar : System.Windows.Forms.UserControl
	{
		internal AlterS.DDButton ddbListTB;
		internal System.Windows.Forms.TextBox txtListTB;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownListWithToolbar()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddbListTB = new AlterS.DDButton();
			this.txtListTB = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// ddbListTB
			// 
			this.ddbListTB.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbListTB.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			this.ddbListTB.AllowDrop = true;
			this.ddbListTB.AllowFocusAndProcessKeyMessages = false;
			this.ddbListTB.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow;
			this.ddbListTB.AutoHideOnLastTab = true;
			this.ddbListTB.AutoSize = false;
			this.ddbListTB.BackColor = System.Drawing.SystemColors.Control;
			this.ddbListTB.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft;
			this.ddbListTB.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D;
			this.ddbListTB.DockPadding.Bottom = 1;
			this.ddbListTB.DockPadding.Left = 1;
			this.ddbListTB.DockPadding.Top = 1;
			this.ddbListTB.DockPaddingRightInternal = 0;
			this.ddbListTB.EnableDrawText = false;
			this.ddbListTB.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbListTB.InternalHeight = 20;
			this.ddbListTB.IsContainer = false;
			this.ddbListTB.IsFormActiveAfterDrop = false;
			this.ddbListTB.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbListTB.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbListTB.Location = new System.Drawing.Point(154, 37);
			this.ddbListTB.Name = "ddbListTB";
			this.ddbListTB.Size = new System.Drawing.Size(17, 20);
			this.ddbListTB.SupportXPStyle = true;
			this.ddbListTB.TabIndex = 11;
			// 
			// txtListTB
			// 
			this.txtListTB.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtListTB.Location = new System.Drawing.Point(24, 35);
			this.txtListTB.Name = "txtListTB";
			this.txtListTB.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.txtListTB.Size = new System.Drawing.Size(120, 20);
			this.txtListTB.TabIndex = 12;
			this.txtListTB.Text = "";
			// 
			// DropDownListWithToolbar
			// 
			this.Controls.Add(this.ddbListTB);
			this.Controls.Add(this.txtListTB);
			this.Name = "DropDownListWithToolbar";
			this.Size = new System.Drawing.Size(194, 92);
			this.ResumeLayout(false);

		}
		#endregion
	
	
	
		private void InitializeDDB(){
			Form frmTmpObj  = new DemoDDB_Csharp.frmTemplateToolbar();
			Control obj;

			ddbListTB.SetFormToDrop(frmTmpObj);
			ddbListTB.SetParentControl(txtListTB);
			obj=(Control)txtListTB;
			ddbListTB.SetObjectToReturnFocus(ref obj);
			ddbListTB.IsFormActiveAfterDrop = true;
			frmTmpObj.Hide();

			ddbListTB.Left = this.Width - ddbListTB.Width;
			txtListTB.Left = 0;
			txtListTB.Width = ddbListTB.Left;

			ddbListTB.Top = 0;
			txtListTB.Top = 0;

			ddbListTB.Resize +=new AlterS.DDButton.ResizeEventHandler(ddbListTB_Resize);
			ddbListTB.Notify +=new AlterS.DDButton.NotifyEventHandler(ddbListTB_Notify);
			txtListTB.Resize +=new EventHandler(txtListTB_Resize);
			this.Resize +=new EventHandler(DropDownListWithToolbar_Resize);

			DropDownListWithToolbar_Resize(null, null);
		}

		private void txtListTB_Resize(object sender, EventArgs e)
		{
			this.Height = txtListTB.Height;
			ddbListTB.Height = txtListTB.Height;
		}

		private void DropDownListWithToolbar_Resize(object sender, EventArgs e)
		{
			ddbListTB.Left = this.Width - ddbListTB.Width;
			txtListTB.Left = 0;
			txtListTB.Width = ddbListTB.Left;
			this.Height = ddbListTB.Height;
		}

		private void ddbListTB_Resize(object sender, EventArgs e)
		{
			// the width of standalone DDButton control may change depending on system settings
			DropDownListWithToolbar_Resize(null, null);
		}

		private void ddbListTB_Notify(ref AlterS.DDButton sender)
		{
			frmTemplateToolbar flst;
			flst = (frmTemplateToolbar)sender.RefToFrmToDrop;
			txtListTB.Text = flst.ValueToSet;
		}
	}
}
