using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DemoDDB_Csharp.DropDown_OptionButtons
{
	/// <summary>
	/// Summary description for DropDownOptionButtons.
	/// </summary>
	public class DropDownOptionButtons : System.Windows.Forms.UserControl
	{
		internal AlterS.DDButton ddbOption;
		internal System.Windows.Forms.TextBox txtOption;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownOptionButtons()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddbOption = new AlterS.DDButton();
			this.txtOption = new System.Windows.Forms.TextBox();
			this.ddbOption.SuspendLayout();
			this.SuspendLayout();
			// 
			// ddbOption
			// 
			this.ddbOption.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbOption.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			this.ddbOption.AllowDrop = true;
			this.ddbOption.AllowFocusAndProcessKeyMessages = false;
			this.ddbOption.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbRightArrow;
			this.ddbOption.AutoHideOnLastTab = true;
			this.ddbOption.AutoSize = false;
			this.ddbOption.BackColor = System.Drawing.SystemColors.Window;
			this.ddbOption.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbButtonTopRight;
			this.ddbOption.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D;
			this.ddbOption.Controls.Add(this.txtOption);
			this.ddbOption.DockPadding.Bottom = 2;
			this.ddbOption.DockPadding.Left = 2;
			this.ddbOption.DockPadding.Right = 18;
			this.ddbOption.DockPadding.Top = 2;
			this.ddbOption.DockPaddingRightInternal = 0;
			this.ddbOption.EnableDrawText = false;
			this.ddbOption.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbOption.InternalHeight = 20;
			this.ddbOption.IsContainer = true;
			this.ddbOption.IsFormActiveAfterDrop = false;
			this.ddbOption.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbOption.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbOption.Location = new System.Drawing.Point(4, 6);
			this.ddbOption.Name = "ddbOption";
			this.ddbOption.Size = new System.Drawing.Size(96, 20);
			this.ddbOption.SupportXPStyle = true;
			this.ddbOption.TabIndex = 14;
			// 
			// txtOption
			// 
			this.txtOption.AutoSize = false;
			this.txtOption.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.txtOption.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtOption.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtOption.Location = new System.Drawing.Point(2, 2);
			this.txtOption.Name = "txtOption";
			this.txtOption.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.txtOption.Size = new System.Drawing.Size(76, 16);
			this.txtOption.TabIndex = 13;
			this.txtOption.Text = "";
			// 
			// DropDownOptionButtons
			// 
			this.Controls.Add(this.ddbOption);
			this.Name = "DropDownOptionButtons";
			this.Size = new System.Drawing.Size(120, 40);
			this.ddbOption.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeDDB()
		{
			Form frmTmpObj  = new DemoDDB_Csharp.frmTemplateToolbar();
			Control obj;


			ddbOption.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			frmTmpObj = (new frmTemplateOption());
			obj=(Control)txtOption;
			ddbOption.SetObjectToReturnFocus(ref obj);
  			ddbOption.SetFormToDrop(frmTmpObj);
			frmTmpObj.Hide();

			ddbOption.Left = 0;
			ddbOption.Top = 0;

			this.Resize +=new EventHandler(DropDownOptionButtons_Resize);
			ddbOption.Notify +=new AlterS.DDButton.NotifyEventHandler(ddbOption_Notify);
			ddbOption.Resize +=new AlterS.DDButton.ResizeEventHandler(ddbOption_Resize);
			DropDownOptionButtons_Resize(null,null);

			ddbOption.DockPadding.All = 2;

		}

		private void DropDownOptionButtons_Resize(object sender, EventArgs e)
		{
			ddbOption.Width = this.Width;

			//since we use ddbTVW.AutoSize = true 
			//we need adjust the control heigth (not the DDButton height)
			this.Height = ddbOption.Height;
		}

		private void ddbOption_Resize(object sender, EventArgs e)
		{
			this.Height = ddbOption.Height;
		}

		private void ddbOption_Notify(ref AlterS.DDButton sender)
		{
			frmTemplateOption fopt;
			fopt=(frmTemplateOption)ddbOption.RefToFrmToDrop;
			txtOption.Text = fopt.ValueToSet;
		}
	}
}
