using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DemoDDB_Csharp.DropDown_Smart_List
{
	/// <summary>
	/// Summary description for DropDownSmartList.
	/// </summary>
	public class DropDownSmartList : System.Windows.Forms.UserControl
	{
		internal AlterS.DDButton ddbSmartList;
		internal System.Windows.Forms.PictureBox picSmartList;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownSmartList()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DropDownSmartList));
			this.ddbSmartList = new AlterS.DDButton();
			this.picSmartList = new System.Windows.Forms.PictureBox();
			this.ddbSmartList.SuspendLayout();
			this.SuspendLayout();
			// 
			// ddbSmartList
			// 
			this.ddbSmartList.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbSmartList.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			this.ddbSmartList.AllowDrop = true;
			this.ddbSmartList.AllowFocusAndProcessKeyMessages = true;
			this.ddbSmartList.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow;
			this.ddbSmartList.AutoHideOnLastTab = false;
			this.ddbSmartList.AutoSize = false;
			this.ddbSmartList.BackColor = System.Drawing.SystemColors.Window;
			this.ddbSmartList.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft;
			this.ddbSmartList.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.ddbSmartList.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbBFlat;
			this.ddbSmartList.Controls.Add(this.picSmartList);
			this.ddbSmartList.DockPadding.Bottom = 1;
			this.ddbSmartList.DockPadding.Left = 19;
			this.ddbSmartList.DockPadding.Right = 18;
			this.ddbSmartList.DockPadding.Top = 1;
			this.ddbSmartList.DockPaddingRightInternal = 1;
			this.ddbSmartList.EnableDrawText = true;
			this.ddbSmartList.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ddbSmartList.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbSmartList.IsContainer = true;
			this.ddbSmartList.IsFormActiveAfterDrop = false;
			this.ddbSmartList.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbSmartList.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbSmartList.Location = new System.Drawing.Point(22, 16);
			this.ddbSmartList.Name = "ddbSmartList";
			this.ddbSmartList.Size = new System.Drawing.Size(192, 21);
			this.ddbSmartList.SupportXPStyle = true;
			this.ddbSmartList.TabIndex = 8;
			this.ddbSmartList.TabStop = true;
			this.ddbSmartList.Tag = "";
			// 
			// picSmartList
			// 
			this.picSmartList.Image = ((System.Drawing.Image)(resources.GetObject("picSmartList.Image")));
			this.picSmartList.Location = new System.Drawing.Point(2, 1);
			this.picSmartList.Name = "picSmartList";
			this.picSmartList.Size = new System.Drawing.Size(16, 16);
			this.picSmartList.TabIndex = 1;
			this.picSmartList.TabStop = false;
			// 
			// DropDownSmartList
			// 
			this.Controls.Add(this.ddbSmartList);
			this.Name = "DropDownSmartList";
			this.Size = new System.Drawing.Size(240, 56);
			this.ddbSmartList.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
	
	
		private void InitializeDDB()
		{
			
			System.Windows.Forms.Control obj;
			frmTemplateSmartList fsl;

			fsl = new frmTemplateSmartList();
			//in this example DDButton does not contain 
			//any element that may receive focus. That's why we
			//set the property AllowFocusAndProcessKeyMessage = True
			ddbSmartList.AllowFocusAndProcessKeyMessages = true;
			ddbSmartList.SetFormToDrop(fsl);
			obj=(Control)ddbSmartList;
			ddbSmartList.SetObjectToReturnFocus(ref obj);
			ddbSmartList.IsFormActiveAfterDrop = true;
			ddbSmartList.AutoSize = true;

			ddbSmartList.Text = "Click here...";
			ddbSmartList.EnableDrawText = true;
	        

			this.picSmartList.Height = 16;
			this.picSmartList.Width = 16;
			picSmartList.Top = ddbSmartList.Height - 8;
			ddbSmartList.DockPadding.Left = picSmartList.Left + picSmartList.Width + 2;
			ddbSmartList.DockPadding.Top = 1;
			ddbSmartList.DockPadding.Bottom = 1;

			this.Resize +=new EventHandler(DropDownSmartList_Resize);
			DropDownSmartList_Resize(null,null);

			ddbSmartList.OnThemeChanged +=new AlterS.DDButton.OnThemeChangedEventHandler(ddbSmartList_OnThemeChanged);
			ddbSmartList.Notify +=new AlterS.DDButton.NotifyEventHandler(ddbSmartList_Notify);
			ddbSmartList.BeforeDropDown +=new AlterS.DDButton.BeforeDropDownEventHandler(ddbSmartList_BeforeDropDown);
			ddbSmartList.Resize +=new AlterS.DDButton.ResizeEventHandler(ddbSmartList_Resize);

			ddbSmartList.Top = 0;
			ddbSmartList.Left = 0;
		}

		private void DropDownSmartList_Resize(object sender, EventArgs e)
		{

			ddbSmartList.Width = this.Width;

			//since we use ddbSmartList.AutoSize = True 
			//we need adjust the control height (not the DDButton height)
			this.Height = ddbSmartList.Height;
		}

		private void ddbSmartList_OnThemeChanged(ref AlterS.DDButton sender, bool IsClassicalStyle)
		{
			if (IsClassicalStyle){
				picSmartList.Top = 1;
			}
			else{
				picSmartList.Top = 3;
			}
		}

		private void ddbSmartList_Notify(ref AlterS.DDButton sender)
		{
			frmTemplateSmartList fsl;

			fsl = (frmTemplateSmartList)ddbSmartList.RefToFrmToDrop;
			ddbSmartList.Text = fsl.ValueToSet;
			picSmartList.Image = fsl.ImageList1.Images[fsl.Type];
		}

		private void ddbSmartList_BeforeDropDown(ref AlterS.DDButton sender, short DropDirection)
		{
			frmTemplateSmartList fsl;
			fsl = (frmTemplateSmartList)ddbSmartList.RefToFrmToDrop;
			fsl.ListView1.Enabled = true;// see frmTemplateSmartList MouseDown event handler
		}

		private void ddbSmartList_Resize(object sender, EventArgs e)
		{
			this.Height = ddbSmartList.Height;
		}
	}
}
