using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DemoDDB_Csharp.DropDown_Tab
{
	/// <summary>
	/// Summary description for DropDownTab.
	/// </summary>
	public class DropDownTab : System.Windows.Forms.UserControl
	{
		internal AlterS.DDButton ddbTab;
		internal System.Windows.Forms.TextBox txtTab;
		internal System.Windows.Forms.PictureBox picTab;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownTab()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddbTab = new AlterS.DDButton();
			this.txtTab = new System.Windows.Forms.TextBox();
			this.picTab = new System.Windows.Forms.PictureBox();
			this.ddbTab.SuspendLayout();
			this.SuspendLayout();
			// 
			// ddbTab
			// 
			this.ddbTab.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbTab.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone;
			this.ddbTab.AllowDrop = true;
			this.ddbTab.AllowFocusAndProcessKeyMessages = false;
			this.ddbTab.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow;
			this.ddbTab.AutoHideOnLastTab = true;
			this.ddbTab.AutoSize = false;
			this.ddbTab.BackColor = System.Drawing.SystemColors.ControlDark;
			this.ddbTab.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft;
			this.ddbTab.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.ddbTab.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D;
			this.ddbTab.Controls.Add(this.txtTab);
			this.ddbTab.Controls.Add(this.picTab);
			this.ddbTab.DockPadding.Bottom = 2;
			this.ddbTab.DockPadding.Left = 23;
			this.ddbTab.DockPadding.Right = 17;
			this.ddbTab.DockPadding.Top = 2;
			this.ddbTab.DockPaddingRightInternal = 0;
			this.ddbTab.EnableDrawText = false;
			this.ddbTab.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbTab.InternalHeight = 24;
			this.ddbTab.IsContainer = true;
			this.ddbTab.IsFormActiveAfterDrop = false;
			this.ddbTab.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbTab.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbTab.Location = new System.Drawing.Point(36, 39);
			this.ddbTab.Name = "ddbTab";
			this.ddbTab.Size = new System.Drawing.Size(144, 28);
			this.ddbTab.SupportXPStyle = true;
			this.ddbTab.TabIndex = 18;
			// 
			// txtTab
			// 
			this.txtTab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtTab.Location = new System.Drawing.Point(22, 2);
			this.txtTab.Name = "txtTab";
			this.txtTab.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.txtTab.TabIndex = 17;
			this.txtTab.Text = "";
			// 
			// picTab
			// 
			this.picTab.BackColor = System.Drawing.SystemColors.ControlDark;
			this.picTab.Location = new System.Drawing.Point(3, 4);
			this.picTab.Name = "picTab";
			this.picTab.Size = new System.Drawing.Size(16, 16);
			this.picTab.TabIndex = 0;
			this.picTab.TabStop = false;
			// 
			// DropDownTab
			// 
			this.Controls.Add(this.ddbTab);
			this.Name = "DropDownTab";
			this.Size = new System.Drawing.Size(226, 98);
			this.ddbTab.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		private void InitializeDDB(){
			System.Windows.Forms.Form frmTmpObj; 
			System.Windows.Forms.Control obj;

			frmTmpObj = (new frmTemplateTab());
			ddbTab.SetFormToDrop(frmTmpObj);
			obj=(Control)txtTab;
			ddbTab.SetObjectToReturnFocus(ref obj);
			ddbTab.IsFormActiveAfterDrop = true;

			ddbTab.Top = 0;
			ddbTab.Left = 0;

			picTab.Width = 16;
			picTab.Height = 16;

			picTab.Left = 3;
			picTab.Top = 4;

			txtTab.Top = 1;
			txtTab.Left = 3 + picTab.Width + 3;

			ddbTab.OnThemeChanged +=new AlterS.DDButton.OnThemeChangedEventHandler(ddbTab_OnThemeChanged);
			ddbTab.Resize +=new AlterS.DDButton.ResizeEventHandler(ddbTab_Resize);
			ddbTab.Notify +=new AlterS.DDButton.NotifyEventHandler(ddbTab_Notify);
			this.Resize +=new EventHandler(DropDownTab_Resize);
			this.FontChanged +=new EventHandler(DropDownTab_FontChanged);
		}

		private void DropDownTab_Resize(object sender, EventArgs e)
		{

			ddbTab.Width = this.Width;

			ddbTab_OnThemeChanged(ref ddbTab,  ddbTab.IsClassicalStyle);

			this.Height = ddbTab.Height;

		}

		private void ddbTab_OnThemeChanged(ref AlterS.DDButton sender, bool IsClassicalStyle)
		{
			txtTab.Width = ddbTab.InternalWidth - txtTab.Left - 1;
  
			if( IsClassicalStyle){
				ddbTab.InternalHeight = txtTab.Height + 3;
			}
			else{
				ddbTab.InternalHeight = txtTab.Height + 1;
			}
		}

		private void ddbTab_Resize(object sender, EventArgs e)
		{
			DropDownTab_Resize(null, null);
		}

		private void ddbTab_Notify(ref AlterS.DDButton sender)
		{
			frmTemplateTab f;
			f = (frmTemplateTab)ddbTab.RefToFrmToDrop;

			txtTab.Text = f.TextToSet;
			picTab.Image = f.ImageList1.Images[f.ObjType];
			txtTab.SelectAll();
		}

		private void DropDownTab_FontChanged(object sender, EventArgs e)
		{
			txtTab.Font = this.Font ;
            DropDownTab_Resize(null, null);
		}
	}
}
