using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DemoDDB_Csharp
{
	/// <summary>
	/// Summary description for TestControl.
	/// </summary>
	public class DropDownTreeView_Editable : System.Windows.Forms.UserControl
	{
		private TextBoxWithNoBeepOnEnter txtTVW;
		public AlterS.DDButton ddbTVW;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownTreeView_Editable()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			InitializeDDB();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddbTVW = new AlterS.DDButton();
			this.txtTVW = new DemoDDB_Csharp.TextBoxWithNoBeepOnEnter();
			this.ddbTVW.SuspendLayout();
			this.SuspendLayout();
			// 
			// ddbTVW
			// 
			this.ddbTVW.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown;
			this.ddbTVW.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbParentAndButtonWidth;
			this.ddbTVW.AllowDrop = true;
			this.ddbTVW.AllowFocusAndProcessKeyMessages = false;
			this.ddbTVW.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow;
			this.ddbTVW.AutoHideOnLastTab = false;
			this.ddbTVW.AutoSize = true;
			this.ddbTVW.BackColor = System.Drawing.SystemColors.Window;
			this.ddbTVW.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft;
			this.ddbTVW.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.ddbTVW.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D;
			this.ddbTVW.Controls.Add(this.txtTVW);
			this.ddbTVW.DockPadding.Bottom = 1;
			this.ddbTVW.DockPadding.Left = 1;
			this.ddbTVW.DockPadding.Right = 19;
			this.ddbTVW.DockPadding.Top = 1;
			this.ddbTVW.DockPaddingRightInternal = 1;
			this.ddbTVW.EnableDrawText = false;
			this.ddbTVW.ImeMode = System.Windows.Forms.ImeMode.On;
			this.ddbTVW.IsContainer = true;
			this.ddbTVW.IsFormActiveAfterDrop = false;
			this.ddbTVW.KeyHide = System.Windows.Forms.Keys.Escape;
			this.ddbTVW.KeyShow = System.Windows.Forms.Keys.Enter;
			this.ddbTVW.Location = new System.Drawing.Point(36, 20);
			this.ddbTVW.Name = "ddbTVW";
			this.ddbTVW.Size = new System.Drawing.Size(196, 21);
			this.ddbTVW.SupportXPStyle = true;
			this.ddbTVW.TabIndex = 0;
			// 
			// txtTVW
			// 
			this.txtTVW.BackColor = System.Drawing.SystemColors.Window;
			this.txtTVW.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.txtTVW.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtTVW.ForeColor = System.Drawing.SystemColors.WindowText;
			this.txtTVW.Location = new System.Drawing.Point(1, 1);
			this.txtTVW.Name = "txtTVW";
			this.txtTVW.Size = new System.Drawing.Size(172, 13);
			this.txtTVW.TabIndex = 1;
			this.txtTVW.Text = "";
			// 
			// DropDownTreeView_Editable
			// 
			this.Controls.Add(this.ddbTVW);
			this.Name = "DropDownTreeView_Editable";
			this.Size = new System.Drawing.Size(284, 68);
			this.ddbTVW.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeDDB()
		{
			this.Resize +=new EventHandler(DropDownTreeView_Editable_Resize);
			ddbTVW.Resize +=new AlterS.DDButton.ResizeEventHandler(ddbTVW_Resize);	

			System.Windows.Forms.Form frmTmpObj; 
			System.Windows.Forms.Control obj;

			frmTmpObj = (new frmTemplateTreeView());
			ddbTVW.SetFormToDrop(frmTmpObj);
			obj=(Control)txtTVW;
			ddbTVW.SetObjectToReturnFocus(ref obj);
			ddbTVW.IsFormActiveAfterDrop = true;
			ddbTVW.AutoSize = true;

			ddbTVW.Notify +=new AlterS.DDButton.NotifyEventHandler( DDButonNotifyHander); 
			ddbTVW.BeforeDropDown += new AlterS.DDButton.BeforeDropDownEventHandler(DDButonBeforeDropDownHandler);
			ddbTVW.AfterFormResize+=new AlterS.DDButton.AfterFormResizeEventHandler(DDButtonAfterFormResize); 

			ddbTVW.OnThemeChanged +=new AlterS.DDButton.OnThemeChangedEventHandler(DDButton_OnThemeChanged);
			txtTVW.KeyDown+=new KeyEventHandler(TVW_parent_KeyDown_Handler);	 

			DropDownTreeView_Editable_Resize(null,null);

		}


		private void DDButonNotifyHander(ref AlterS.DDButton sender)
		{
			frmTemplateTreeView ftv;
			ftv = (frmTemplateTreeView)sender.RefToFrmToDrop;
			txtTVW.Text = ftv.ValueToSet;
		}

		private void DDButonBeforeDropDownHandler(ref AlterS.DDButton sender, short DropDirection)
		{
			frmTemplateTreeView ftv;

			AlterS.Grip g;
			nmsAux.clsAux c;

			c= (new nmsAux.clsAux());

			ftv = (frmTemplateTreeView)sender.RefToFrmToDrop;
			g = ftv.Grip1;
			c.ChangeGripPosition(g, DropDirection);
			ftv.Enabled = true; //for details see the frmTemplateTreeView/tvw_MouseUp event handler
		}

		private void DDButtonAfterFormResize(ref AlterS.DDButton sender, short DropDirection)
		{
			DDButonBeforeDropDownHandler(ref sender, DropDirection);
		}

		private void DDButton_OnThemeChanged(ref AlterS.DDButton sender, bool IsClassicalStyle)
		{
			if( IsClassicalStyle){
				txtTVW.Dock = DockStyle.Fill;
			}
			else{
				txtTVW.Dock = DockStyle.None;
				txtTVW.Width = ddbTVW.InternalWidth - 2;
				txtTVW.Top = 3;
				txtTVW.Left = 3;
			}
		}
		

		private void TVW_parent_KeyDown_Handler(object sender, KeyEventArgs e)
		{
			frmTemplateTreeView f;
			f = (frmTemplateTreeView)ddbTVW.RefToFrmToDrop;

			if (f !=null){

				switch (e.KeyCode)
				{
					case (Keys.Enter):
						if (! f.Visible){
							ddbTVW.DropDown(0,0,0);
						}
						else{
							ddbTVW.HideDroppedForm();
						}
						e.Handled = true;
						break;

					case (Keys.Down):
						if (! f.Visible){
							ddbTVW.DropDown(0,0,0);
						}
						else{
							ddbTVW.SetDroppedFormAsActive();	
						}
						break;
					default:
						break;
				}//sw
			}//if f
		}


		private void DropDownTreeView_Editable_Resize(object sender, EventArgs e)
		{
			ddbTVW.Top = 0;
			ddbTVW.Left = 0;
			ddbTVW.Width = this.Width;

			//since we use ddbTVW.AutoSize = true 
			//we need adjust the control heigth (not the DDButton height)
			this.Height = ddbTVW.Height;
		}

		private void ddbTVW_Resize(object sender, EventArgs e)
		{
			this.Height = ddbTVW.Height;
		}
	}
}
