using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DemoDDB_Csharp
{
	/// <summary>
	/// Summary description for frmTemplateTreeView.
	/// </summary>
	public class frmTemplateTreeView : System.Windows.Forms.Form
	{

		public AlterS.DDButton ParentDDButton;   
		public string ValueToSet;
		public bool SupressDataExch;
		internal DemoDDB_Csharp.TreeViewWithNoBeepOnEnter tvw;
		internal AlterS.Grip Grip1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmTemplateTreeView()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Grip1 = new AlterS.Grip();
			this.tvw = new DemoDDB_Csharp.TreeViewWithNoBeepOnEnter();
			this.SuspendLayout();
			// 
			// Grip1
			// 
			this.Grip1.AdjustXShift = 1;
			this.Grip1.AdjustYShift = 1;
			this.Grip1.AutoAdjustPosition = true;
			this.Grip1.BackColor = System.Drawing.Color.Yellow;
			this.Grip1.EdgeStyle = AlterS.GripEnum.EdgeStyles.BUMP;
			this.Grip1.Location = new System.Drawing.Point(180, 132);
			this.Grip1.Name = "Grip1";
			this.Grip1.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpBOTTOM_RIGHT;
			this.Grip1.Size = new System.Drawing.Size(8, 8);
			this.Grip1.Style = AlterS.GripEnum.GripStyles.grpSquare;
			this.Grip1.TabIndex = 3;
			this.Grip1.TabStop = false;
			// 
			// tvw
			// 
			this.tvw.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tvw.ImageIndex = -1;
			this.tvw.Location = new System.Drawing.Point(0, 0);
			this.tvw.Name = "tvw";
			this.tvw.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																			new System.Windows.Forms.TreeNode("Use the small yellow square to resize the drop-down part"),
																			new System.Windows.Forms.TreeNode("Australia", new System.Windows.Forms.TreeNode[] {
																																								   new System.Windows.Forms.TreeNode("Canberra"),
																																								   new System.Windows.Forms.TreeNode("Melbourne"),
																																								   new System.Windows.Forms.TreeNode("Sydney")}),
																			new System.Windows.Forms.TreeNode("Germany", new System.Windows.Forms.TreeNode[] {
																																								 new System.Windows.Forms.TreeNode("Berlin"),
																																								 new System.Windows.Forms.TreeNode("Dresden"),
																																								 new System.Windows.Forms.TreeNode("Munich")}),
																			new System.Windows.Forms.TreeNode("United States", new System.Windows.Forms.TreeNode[] {
																																									   new System.Windows.Forms.TreeNode("Dallas"),
																																									   new System.Windows.Forms.TreeNode("New-York"),
																																									   new System.Windows.Forms.TreeNode("Washington")})});
			this.tvw.SelectedImageIndex = -1;
			this.tvw.Size = new System.Drawing.Size(212, 164);
			this.tvw.TabIndex = 2;
			// 
			// frmTemplateTreeView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(212, 164);
			this.Controls.Add(this.Grip1);
			this.Controls.Add(this.tvw);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "frmTemplateTreeView";
			this.ShowInTaskbar = false;
			this.Text = "frmTemplateTreeView";
			this.Load += new System.EventHandler(this.frmTemplateTreeView_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void frmTemplateTreeView_Load(object sender, System.EventArgs e)
		{

			Object o;
			o=this;
			Grip1.SetObjectToResize(ref o);
      
			tvw.Nodes[0].EnsureVisible();
			tvw.BorderStyle = BorderStyle.FixedSingle;
			SupressDataExch = false;
			
			tvw.MouseUp+=new MouseEventHandler(tvw_MouseUp); 
			tvw.BeforeCollapse +=new TreeViewCancelEventHandler(tvw_BeforeCollapse);
			tvw.BeforeExpand +=new TreeViewCancelEventHandler(tvw_BeforeExpand);
			tvw.MouseMove +=new MouseEventHandler(tvw_MouseMove);
			tvw.KeyDown +=new KeyEventHandler(tvw_KeyDown);
		}

		protected override void OnResize(EventArgs e)
		{
			if (this.Width <= 10) {this.Width = 10;};
			if (this.Height <= 10) {this.Height = 10;};
			tvw.Focus();
			base.OnResize (e);
		}

		private void tvw_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e )
		{
			Point pt;	
			pt = new Point();

			pt.X = e.X;
			pt.Y = e.Y;

			if (tvw.GetNodeAt(pt) == null) 
			{
				return;
			};

			if (SupressDataExch) 
			{
				SupressDataExch = false;
				return;
			}

			if (e.Button == MouseButtons.Left) 
			{
				if (ParentDDButton != null)
				{
					ValueToSet = tvw.SelectedNode.FullPath;

					this.Enabled = false ;
					//In the code above we disable the dropdown form before it is hidden.
					//This should be done because the TreeView control tries to 
					//return focus after the form is hidden. If this happens, 
					//the main form becomes inactive (this gives unwanted 
					//visual effects). The form will be enabled in the Notify event 
					//handler. The control is enabled in the 
					//ddbTVW_BeforeDropDown event handler.
					//Another control that may try to return focus 
					//in such situation is ListView. 

					ParentDDButton.RaiseEventNotify();
					ParentDDButton.HideDroppedForm();
				}
			}

		}

		private void tvw_BeforeCollapse(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			SupressDataExch = true;
		}

		private void tvw_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			SupressDataExch = true;
		}

		private void tvw_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{

			Point pt;	
			TreeNode n;

			pt = new Point();

			pt.X = e.X;
			pt.Y = e.Y;

			n = tvw.GetNodeAt(pt);
			if (n!=null){
				tvw.SelectedNode = n;
			}
		}

		private void tvw_KeyDown(object sender, KeyEventArgs e)
		{

			switch (e.KeyCode){
				case (Keys.Enter):
					if  (ParentDDButton!=null){
						ValueToSet = tvw.SelectedNode.FullPath;
						ParentDDButton.RaiseEventNotify();
						ParentDDButton.HideDroppedForm();
					}
	                e.Handled = true;
					break;

				case (Keys.Escape):
					if  (ParentDDButton!=null)
					{
						ParentDDButton.HideDroppedForm();
					}
					e.Handled = true;
					break;
				case (Keys.Up):

					if (tvw.SelectedNode.Parent == null & tvw.SelectedNode.Index == 0){
					
						if  (ParentDDButton!=null)
						{
							ParentDDButton.ReturnFocusToParentControl();
							e.Handled = true;
						}
					}
					break;

				default:
				break;
			}
		}
	}
}
