Public Class AutoComplete
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        InitializeDDB()
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ddbAutoComplete As AlterS.DDButton
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.ddbAutoComplete = New AlterS.DDButton
        Me.SuspendLayout()
        '
        'ddbAutoComplete
        '
        Me.ddbAutoComplete.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown
        Me.ddbAutoComplete.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone
        Me.ddbAutoComplete.AllowDrop = True
        Me.ddbAutoComplete.AllowFocusAndProcessKeyMessages = False
        Me.ddbAutoComplete.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow
        Me.ddbAutoComplete.AutoHideOnLastTab = True
        Me.ddbAutoComplete.AutoSize = False
        Me.ddbAutoComplete.BackColor = System.Drawing.SystemColors.Window
        Me.ddbAutoComplete.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft
        Me.ddbAutoComplete.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D
        Me.ddbAutoComplete.DockPadding.Bottom = 1
        Me.ddbAutoComplete.DockPadding.Left = 1
        Me.ddbAutoComplete.DockPadding.Right = 17
        Me.ddbAutoComplete.DockPadding.Top = 1
        Me.ddbAutoComplete.DockPaddingRightInternal = 0
        Me.ddbAutoComplete.EnableDrawText = False
        Me.ddbAutoComplete.ImeMode = System.Windows.Forms.ImeMode.On
        Me.ddbAutoComplete.IsContainer = False
        Me.ddbAutoComplete.IsFormActiveAfterDrop = False
        Me.ddbAutoComplete.KeyHide = System.Windows.Forms.Keys.Escape
        Me.ddbAutoComplete.KeyShow = System.Windows.Forms.Keys.Enter
        Me.ddbAutoComplete.Location = New System.Drawing.Point(4, 4)
        Me.ddbAutoComplete.Name = "ddbAutoComplete"
        Me.ddbAutoComplete.Size = New System.Drawing.Size(16, 32)
        Me.ddbAutoComplete.SupportXPStyle = True
        Me.ddbAutoComplete.TabIndex = 3
        '
        'AutoComplete
        '
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.Controls.Add(Me.ddbAutoComplete)
        Me.Name = "AutoComplete"
        Me.Size = New System.Drawing.Size(24, 42)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private WithEvents txtAutoComplete As TextBox
    Private PositionToInsert As Integer

    Private Sub InitializeDDB()
        Dim frmTmpObj As Form
        frmTmpObj = New frmTemplateAutoComplete
        ddbAutoComplete.IsContainer = False
        ddbAutoComplete.SetFormToDrop(frmTmpObj)
    End Sub

    Public Sub SetParentControl(ByVal tb As TextBox)
        txtAutoComplete = tb
        ddbAutoComplete.SetParentControl(tb)
    End Sub

    Private Sub txtAutoComplete_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtAutoComplete.KeyDown

        Dim f As frmTemplateAutoComplete
        f = ddbAutoComplete.RefToFrmToDrop

        If f Is Nothing Then Exit Sub

        If f.Visible Then
            Select Case e.KeyValue
                Case Keys.Escape
                    ddbAutoComplete.HideDroppedForm()
                Case Keys.Down, Keys.Up
                    ddbAutoComplete.SetDroppedFormAsActive()
                    f.ListBox1.Focus()
                    e.Handled = True
                Case Else
                    '
            End Select

        End If
    End Sub


    Private Sub txtAutoComplete_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtAutoComplete.KeyPress
        Dim f As frmTemplateAutoComplete
        Dim p As New POINTAPI
        Dim KeyAscii As Integer


        f = ddbAutoComplete.RefToFrmToDrop

        If f Is Nothing Then Exit Sub

        KeyAscii = Asc(e.KeyChar)

        If f.Visible Then f.HandleKeyPressInParentControl(KeyAscii)

        If KeyAscii = Keys.Enter And f.Visible Then
            e.Handled = True
            f.DataExchMode = 1
            ddbAutoComplete_Notify(Nothing)
            ddbAutoComplete.HideDroppedForm()
            Exit Sub
        End If

        ' show autocomplete tool on "."
        If KeyAscii = 46 And Not f.Visible Then
            PositionToInsert = txtAutoComplete.SelectionStart + 1

            '--------- Initialize variables
            f.ListBox1.SelectedIndex = 0
            f.IsMouseClick = False
            '---------------------------------------

            GetCaretPos(p)
            ClientToScreen(CLng(txtAutoComplete.Handle.ToInt32), p)

            ddbAutoComplete.DropDown(p.x, (p.y + 2 * txtAutoComplete.Font.Size), 2 * txtAutoComplete.Font.Size)

            Exit Sub
        End If

        ' this is to supress change of the text 
        ' when auto complete tool is visible
        If f.Visible Then e.Handled = True

    End Sub


    Private Sub ddbAutoComplete_Notify(ByRef sender As AlterS.DDButton) Handles ddbAutoComplete.Notify
        Dim f As frmTemplateAutoComplete
        Dim txtToIns As String
        Dim basetxt As String

        f = ddbAutoComplete.RefToFrmToDrop

        If f Is Nothing Then Exit Sub

        txtToIns = f.ListBox1.Items(f.ListBox1.SelectedIndex)
        basetxt = txtAutoComplete.Text
        Select Case f.DataExchMode
            Case 1
                txtAutoComplete.Text = _
            Mid(basetxt, 1, PositionToInsert) & _
            txtToIns & _
            Mid(basetxt, PositionToInsert + 1, Len(basetxt) - PositionToInsert)

                txtAutoComplete.SelectionStart = _
                PositionToInsert + Len(txtToIns)
            Case 2
                'txtAutoComplete.Text = txtAutoComplete.Text & f.TypedChar
        End Select

    End Sub

    Private Sub AutoComplete_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ddbAutoComplete.Top = 0
        ddbAutoComplete.Left = 0
        Me.Height = ddbAutoComplete.Height
        Me.Width = ddbAutoComplete.Width
    End Sub
End Class
