Public Class frmTemplateDataGrid
    Inherits System.Windows.Forms.Form

    Public WithEvents ParentDDButton As AlterS.DDButton
    Public ValueToSet As String

    Private Const InitRowSel As Integer = -2 ' since HitTest returns -1 when no row selected lets use -2 
    Private PrevRowSel As Integer = InitRowSel
    Private Const border_width As Integer = 1

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        LoadData()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents DataSet1 As System.Data.DataSet
    Friend WithEvents DataGrid1 As DataGridWithKeyDownEvents
    Friend WithEvents Grip1 As AlterS.Grip
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.DataSet1 = New System.Data.DataSet
        Me.DataGrid1 = New DemoDDButtonVB.DataGridWithKeyDownEvents
        Me.Grip1 = New AlterS.Grip
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        CType(Me.DataSet1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'DataSet1
        '
        Me.DataSet1.DataSetName = "NewDataSet"
        Me.DataSet1.Locale = New System.Globalization.CultureInfo("en-US")
        '
        'DataGrid1
        '
        Me.DataGrid1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(1, 1)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(294, 198)
        Me.DataGrid1.TabIndex = 0
        '
        'Grip1
        '
        Me.Grip1.AdjustXShift = 1
        Me.Grip1.AdjustYShift = 1
        Me.Grip1.AutoAdjustPosition = True
        Me.Grip1.BackColor = System.Drawing.Color.Yellow
        Me.Grip1.EdgeStyle = AlterS.GripEnum.EdgeStyles.BUMP
        Me.Grip1.Location = New System.Drawing.Point(248, 164)
        Me.Grip1.Name = "Grip1"
        Me.Grip1.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpBOTTOM_RIGHT
        Me.Grip1.Size = New System.Drawing.Size(8, 8)
        Me.Grip1.Style = AlterS.GripEnum.GripStyles.grpSquare
        Me.Grip1.TabIndex = 1
        Me.Grip1.TabStop = False
        '
        'frmTemplateDataGrid
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.WindowFrame
        Me.ClientSize = New System.Drawing.Size(296, 200)
        Me.Controls.Add(Me.Grip1)
        Me.Controls.Add(Me.DataGrid1)
        Me.DockPadding.All = 1
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.KeyPreview = True
        Me.Name = "frmTemplateDataGrid"
        Me.ShowInTaskbar = False
        Me.Text = "frmTemplateDataGrid"
        CType(Me.DataSet1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region


    Public Sub LoadData()
        Dim dataTable1 As New DataTable("Books")
        Dim dc1 As New DataColumn("Author")
        Dim dc2 As New DataColumn("Book")
        Dim grdTableStyle1 As New DataGridTableStyle
        Dim grdColStyle1 As New DataGridTextBoxColumn
        Dim grdColStyle2 As New DataGridTextBoxColumn
        Dim a(1) As String
        Dim i As Integer

        Grip1.SetObjectToResize(Me)

        Me.DockPadding.All = border_width


        dataTable1.Columns.Add(dc1)
        dataTable1.Columns.Add(dc2)

        DataSet1.Tables.Add(dataTable1)

        For i = 1 To 100
            a(0) = "Author name " & i
            a(1) = "Book title " & (100 - i)
            DataSet1.Tables(0).Rows.Add(a)
        Next

        With grdColStyle1
            .HeaderText = "Author"
            .MappingName = "Author"
            .Width = 100
        End With

        With grdColStyle2
            .HeaderText = "Book"
            .MappingName = "Book"
            .Width = 125
        End With

        grdTableStyle1.AlternatingBackColor = Color.AliceBlue
        grdTableStyle1.HeaderBackColor = Color.LightSlateGray
        grdTableStyle1.HeaderForeColor = Color.White
        DataGrid1.BackgroundColor = Color.WhiteSmoke



        grdTableStyle1.RowHeaderWidth = 25
        grdTableStyle1.MappingName = "Books"
        grdTableStyle1.GridColumnStyles.AddRange _
            (New DataGridColumnStyle() _
            {grdColStyle1, grdColStyle2})

        DataGrid1.CaptionVisible = False
        DataGrid1.ReadOnly = True
        DataGrid1.DataSource = DataSet1.Tables(0)
        DataGrid1.TableStyles.Add(grdTableStyle1)
    End Sub


    Private Sub DataGrid1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGrid1.MouseDown

        If e.Button = MouseButtons.Left Then
            ' Use the HitTest method to get a HitTestInfo object.
            Dim hi As DataGrid.HitTestInfo
            Dim grid As DataGrid = CType(sender, DataGrid)
            Dim c As DataGridCell

            hi = grid.HitTest(e.X, e.Y)
            ' Test if the clicked area was a cell.
            If hi.Type = System.Windows.Forms.DataGrid.HitTestType.Cell Then

                If Not ParentDDButton Is Nothing Then
                    ValueToSet = DataGrid1.Item(hi.Row, 1) _
                        & ", " & DataGrid1.Item(hi.Row, 0)
                    ParentDDButton.RaiseEventNotify()
                    ParentDDButton.HideDroppedForm()

                End If
            End If
        End If

    End Sub


    Private Sub DataGrid1_KeyDown(ByVal sender As Object, _
        ByVal Key As System.Windows.Forms.Keys) _
        Handles DataGrid1.KeyDown

        Select Case Key
            Case Keys.Enter
                If Not ParentDDButton Is Nothing Then
                    ValueToSet = """" & _
                        DataGrid1.Item(DataGrid1.CurrentRowIndex, 1) _
                        & """, " & _
                        DataGrid1.Item(DataGrid1.CurrentRowIndex, 0)
                    ParentDDButton.RaiseEventNotify()
                    ParentDDButton.HideDroppedForm()
                End If
            Case Keys.Escape
                If Not ParentDDButton Is Nothing Then
                    ParentDDButton.HideDroppedForm()
                End If
        End Select
    End Sub

    Private Sub DataGrid1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGrid1.MouseMove
        Static X As Integer
        Static Y As Integer

        If X = e.X And Y = e.Y Then
            Exit Sub 'No move. Sometimes DataGrid fires the MouseMove event when there is no real move.
        End If

        X = e.X
        Y = e.Y


        If e.Button = MouseButtons.None Then
            ' Use the HitTest method to get a HitTestInfo object.
            Dim hi As DataGrid.HitTestInfo
            Dim grid As DataGrid = CType(sender, DataGrid)
            Dim c As DataGridCell

            hi = grid.HitTest(e.X, e.Y)
            If PrevRowSel = hi.Row Or hi.Row = -1 Then Exit Sub
            ' Test if the clicked area was a cell.
            If hi.Type = System.Windows.Forms.DataGrid.HitTestType.Cell Then
                If PrevRowSel <> InitRowSel Then
                    DataGrid1.UnSelect(PrevRowSel)
                Else
                    DataGrid1.UnSelect(0)
                End If
                DataGrid1.Select(hi.Row)
                DataGrid1.CurrentRowIndex = hi.Row
                PrevRowSel = hi.Row
            End If
        End If


    End Sub

    Private Sub ParentDDButton_AfterDropDown(ByRef sender As AlterS.DDButton, ByVal DropDirection As Short) Handles ParentDDButton.AfterDropDown
        If PrevRowSel = InitRowSel Then
            DataGrid1.Select(0)
        Else
            DataGrid1.Select(PrevRowSel)
        End If
    End Sub

    Private Sub DataGrid1_CurrentCellChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGrid1.CurrentCellChanged

        If PrevRowSel <> InitRowSel Then
            DataGrid1.UnSelect(PrevRowSel)
        End If
        DataGrid1.Select(DataGrid1.CurrentRowIndex)
        PrevRowSel = DataGrid1.CurrentRowIndex
    End Sub

    
    Private Sub Grip1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Grip1.GotFocus
        DataGrid1.Focus()
    End Sub



End Class
