Public Class DropDownTab
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        InitializeDDB()

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ddbTab As AlterS.DDButton
    Friend WithEvents txtTab As System.Windows.Forms.TextBox
    Friend WithEvents picTab As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.ddbTab = New AlterS.DDButton
        Me.txtTab = New System.Windows.Forms.TextBox
        Me.picTab = New System.Windows.Forms.PictureBox
        Me.ddbTab.SuspendLayout()
        Me.SuspendLayout()
        '
        'ddbTab
        '
        Me.ddbTab.AccessibleRole = System.Windows.Forms.AccessibleRole.ButtonDropDown
        Me.ddbTab.AdjustWidthOfDroppedForm = AlterS.DDBEnum.ddbAdjustWidth.ddbNone
        Me.ddbTab.AllowDrop = True
        Me.ddbTab.AllowFocusAndProcessKeyMessages = False
        Me.ddbTab.ArrowStyle = AlterS.DDBEnum.ddbArrowStyle.ddbDownArrow
        Me.ddbTab.AutoHideOnLastTab = False
        Me.ddbTab.AutoSize = False
        Me.ddbTab.BackColor = System.Drawing.SystemColors.ControlDark
        Me.ddbTab.BindPosition = AlterS.DDBEnum.ddbPointToBind.ddbParentBottomLeft
        Me.ddbTab.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.ddbTab.ButtonStyle = AlterS.DDBEnum.ddbButtonStyle.ddbB3D
        Me.ddbTab.Controls.Add(Me.txtTab)
        Me.ddbTab.Controls.Add(Me.picTab)
        Me.ddbTab.DockPadding.Bottom = 1
        Me.ddbTab.DockPadding.Left = 19
        Me.ddbTab.DockPadding.Right = 17
        Me.ddbTab.DockPadding.Top = 1
        Me.ddbTab.DockPaddingRightInternal = 0
        Me.ddbTab.EnableDrawText = False
        Me.ddbTab.ImeMode = System.Windows.Forms.ImeMode.On
        Me.ddbTab.InternalHeight = 24
        Me.ddbTab.IsContainer = True
        Me.ddbTab.IsFormActiveAfterDrop = False
        Me.ddbTab.KeyHide = System.Windows.Forms.Keys.Escape
        Me.ddbTab.KeyShow = System.Windows.Forms.Keys.Enter
        Me.ddbTab.Location = New System.Drawing.Point(60, 34)
        Me.ddbTab.Name = "ddbTab"
        Me.ddbTab.Size = New System.Drawing.Size(162, 28)
        Me.ddbTab.SupportXPStyle = True
        Me.ddbTab.TabIndex = 19
        '
        'txtTab
        '
        Me.txtTab.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtTab.Location = New System.Drawing.Point(32, 2)
        Me.txtTab.Name = "txtTab"
        Me.txtTab.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtTab.Size = New System.Drawing.Size(106, 20)
        Me.txtTab.TabIndex = 17
        Me.txtTab.Text = ""
        '
        'picTab
        '
        Me.picTab.BackColor = System.Drawing.SystemColors.ControlDark
        Me.picTab.Location = New System.Drawing.Point(3, 4)
        Me.picTab.Name = "picTab"
        Me.picTab.Size = New System.Drawing.Size(16, 16)
        Me.picTab.TabIndex = 0
        Me.picTab.TabStop = False
        '
        'DropDownTab
        '
        Me.Controls.Add(Me.ddbTab)
        Me.Name = "DropDownTab"
        Me.Size = New System.Drawing.Size(264, 96)
        Me.ddbTab.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub InitializeDDB()
        Dim frmTmpObj As Form

        frmTmpObj = New frmTemplateTab
        ddbTab.SetFormToDrop(frmTmpObj)
        ddbTab.SetObjectToReturnFocus(txtTab)
        ddbTab.IsFormActiveAfterDrop = True

        ddbTab.Top = 0
        ddbTab.Left = 0

        picTab.Width = 16
        picTab.Height = 16

        picTab.Left = 3
        picTab.Top = 4

        txtTab.Top = 1
        txtTab.Left = 3 + picTab.Width + 3
    End Sub


    Private Sub DropDownTab_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize


        ddbTab.Width = Me.Width

        ddbTab_OnThemeChanged(ddbTab, ddbTab.IsClassicalStyle)

        Me.Height = ddbTab.Height
    End Sub



    Private Sub ddbTab_OnThemeChanged(ByRef sender As AlterS.DDButton, ByVal IsClassicalStyle As Boolean) Handles ddbTab.OnThemeChanged
        txtTab.Width = ddbTab.InternalWidth - txtTab.Left - 1

        If IsClassicalStyle Then
            ddbTab.InternalHeight = txtTab.Height + 3
        Else
            ddbTab.InternalHeight = txtTab.Height + 1
        End If

    End Sub

    Private Sub ddbTab_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddbTab.Resize
        DropDownTab_Resize(Nothing, Nothing)
    End Sub

    Public Overrides Property Font() As System.Drawing.Font
        Get
            Return txtTab.Font
        End Get
        Set(ByVal Value As System.Drawing.Font)
            txtTab.Font = Value
            ddbTab_Resize(Nothing, Nothing)
        End Set
    End Property

    Private Sub ddbTab_Notify(ByRef sender As AlterS.DDButton) Handles ddbTab.Notify
        Dim f As frmTemplateTab
        f = ddbTab.RefToFrmToDrop

        txtTab.Text = f.TextToSet
        picTab.Image = f.ImageList1.Images(f.ObjType)
        txtTab.SelectAll()
    End Sub
End Class
