
Public Class frmTemplateTreeView
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        InitParams()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tvw As DemoDDButtonVB.TreeViewWithNoBeepOnEnter 'TreeView
    Friend WithEvents Grip1 As AlterS.Grip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Grip1 = New AlterS.Grip
        Me.tvw = New DemoDDButtonVB.TreeViewWithNoBeepOnEnter
        Me.SuspendLayout()
        '
        'Grip1
        '
        Me.Grip1.AdjustXShift = 1
        Me.Grip1.AdjustYShift = 1
        Me.Grip1.AutoAdjustPosition = True
        Me.Grip1.BackColor = System.Drawing.Color.Yellow
        Me.Grip1.EdgeStyle = AlterS.GripEnum.EdgeStyles.BUMP
        Me.Grip1.Location = New System.Drawing.Point(152, 136)
        Me.Grip1.Name = "Grip1"
        Me.Grip1.ResizeDirection = AlterS.GripEnum.GripResizeDirection.grpBOTTOM_RIGHT
        Me.Grip1.Size = New System.Drawing.Size(8, 8)
        Me.Grip1.Style = AlterS.GripEnum.GripStyles.grpSquare
        Me.Grip1.TabIndex = 1
        Me.Grip1.TabStop = False
        '
        'tvw
        '
        Me.tvw.Dock = System.Windows.Forms.DockStyle.Fill
        Me.tvw.ImageIndex = -1
        Me.tvw.Location = New System.Drawing.Point(0, 0)
        Me.tvw.Name = "tvw"
        Me.tvw.Nodes.AddRange(New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("Use the small yellow square to resize the drop-down part"), New System.Windows.Forms.TreeNode("Australia", New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("Canberra"), New System.Windows.Forms.TreeNode("Melbourne"), New System.Windows.Forms.TreeNode("Sydney")}), New System.Windows.Forms.TreeNode("Germany", New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("Berlin"), New System.Windows.Forms.TreeNode("Dresden"), New System.Windows.Forms.TreeNode("Munich")}), New System.Windows.Forms.TreeNode("United States", New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("Dallas"), New System.Windows.Forms.TreeNode("New-York"), New System.Windows.Forms.TreeNode("Washington")})})
        Me.tvw.SelectedImageIndex = -1
        Me.tvw.Size = New System.Drawing.Size(180, 160)
        Me.tvw.TabIndex = 2
        '
        'frmTemplateTreeView
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(180, 160)
        Me.ControlBox = False
        Me.Controls.Add(Me.Grip1)
        Me.Controls.Add(Me.tvw)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.Name = "frmTemplateTreeView"
        Me.ShowInTaskbar = False
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public ParentDDButton As AlterS.DDButton
    Public ValueToSet As String
    Public SupressDataExch As Boolean

    Private Sub InitParams()
        Grip1.SetObjectToResize(Me)
        tvw.Nodes(0).EnsureVisible()
        tvw.BorderStyle = BorderStyle.FixedSingle
        SupressDataExch = False
    End Sub


    Private Sub frmTemplateTreeView_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If Me.Width <= 10 Then Me.Width = 10
        If Me.Height <= 10 Then Me.Height = 10

        tvw.Focus()
    End Sub

    'In the case  of TreeView it is strongly recommended to use MouseUp event. Otherwise MS bugs...
    Private Sub tvw_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvw.MouseUp
        Dim pt As New Point

        pt.X = e.X
        pt.Y = e.Y

        If tvw.GetNodeAt(pt) Is Nothing Then Exit Sub

        If SupressDataExch Then
            SupressDataExch = False
            Exit Sub
        End If
        If e.Button = MouseButtons.Left Then
            If Not ParentDDButton Is Nothing Then
                ValueToSet = tvw.SelectedNode.FullPath

                Me.Enabled = False
                'In the code above we disable the dropdown form before it is hidden.
                'This should be done because the TreeView control tries to 
                'return focus after the form is hidden. If this happens, 
                'the main form becomes inactive (this gives unwanted 
                'visual effects). The control is enabled in the 
                'ddbTVW_BeforeDropDown event handler.
                'Another control that may try to return focus 
                'in such situation is ListView. 

                ParentDDButton.RaiseEventNotify()
                ParentDDButton.HideDroppedForm()
            End If
        End If
    End Sub

    Private Sub tvw_BeforeCollapse(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles tvw.BeforeCollapse
        SupressDataExch = True
    End Sub

    Private Sub tvw_BeforeExpand(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles tvw.BeforeExpand
        SupressDataExch = True
    End Sub

    Private Sub tvw_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tvw.KeyDown
        Select Case e.KeyCode
            Case Keys.Enter
                If Not ParentDDButton Is Nothing Then
                    ValueToSet = tvw.SelectedNode.FullPath
                    ParentDDButton.RaiseEventNotify()
                    ParentDDButton.HideDroppedForm()
                End If
                e.Handled = True
            Case Keys.Escape
                If Not ParentDDButton Is Nothing Then
                    ParentDDButton.HideDroppedForm()
                End If
                e.Handled = True
        End Select
        If e.KeyCode = Keys.Up Then
            If tvw.SelectedNode.Parent Is Nothing And tvw.SelectedNode.Index = 0 Then
                If Not ParentDDButton Is Nothing Then
                    ParentDDButton.ReturnFocusToParentControl()
                End If
                e.Handled = True
            End If
        End If
    End Sub


    Private Sub tvw_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvw.MouseMove
        Dim pt As New Point
        Dim n As TreeNode

        pt.X = e.X
        pt.Y = e.Y
        n = tvw.GetNodeAt(pt)
        If Not n Is Nothing Then
            tvw.SelectedNode = n
        End If
    End Sub

End Class
